/*
 * Copyright (C) 2008 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

#ifndef __AS_FILE_ENTRY_H__
#define __AS_FILE_ENTRY_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define AS_TYPE_FILE_ENTRY          (as_file_entry_get_type ())
#define AS_FILE_ENTRY(obj)          (G_TYPE_CHECK_INSTANCE_CAST ((obj), AS_TYPE_FILE_ENTRY, ASFileEntry))
#define AS_FILE_ENTRY_CLASS(klass)  (G_TYPE_CHECK_CLASS_CAST ((klass), AS_TYPE_FILE_ENTRY, ASFileEntryClass))
#define AS_IS_FILE_ENTRY(obj)       (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AS_TYPE_FILE_ENTRY))
#define AS_IS_FILE_ENTRY_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((obj), AS_TYPE_FILE_ENTRY))

typedef struct _ASFileEntryPrivate ASFileEntryPrivate;
typedef struct _ASFileEntryClass   ASFileEntryClass;
typedef struct _ASFileEntry        ASFileEntry;

struct _ASFileEntryClass
{
    GtkHBoxClass __parent__;

    /* signals */
    void (*entry_changed)   (ASFileEntry *fe);
};

struct _ASFileEntry
{
    GtkHBox box;

    /* private */
    ASFileEntryPrivate *priv;
};

GType                 as_file_entry_get_type (void) G_GNUC_CONST;
GtkWidget            *as_file_entry_new (const gchar *title,
                                         GtkFileChooserAction action,
                                         const gchar *file);

const gchar           *as_file_entry_get_filename (ASFileEntry *fe);
void                   as_file_entry_set_filename (ASFileEntry *fe,
                                         const gchar *text);
GtkFileChooserAction   as_file_entry_get_action (ASFileEntry *fe);
void                   as_file_entry_set_action (ASFileEntry *fe,
                                         GtkFileChooserAction action);
const gchar           *as_file_entry_get_title (ASFileEntry *fe);
void                   as_file_entry_set_title (ASFileEntry *fe,
                                         const gchar *title);

G_END_DECLS

#endif /* __AS_FILE_ENTRY_H__ */
